Subject: Re: [PATCH net] nfp: do not use driver_data to index device info

From: Simon Horman <[email-masked]>
Date: Fri, 1 Apr 2022 15:51:25 +0200

On Fri, Apr 01, 2022 at 03:18:43PM +0200, Andrew Lunn wrote:
> On Fri, Apr 01, 2022 at 01:19:36PM +0200, Simon Horman wrote:
> > From: Niklas Söderlund <[email-masked]>
> > 
> > When adding support for multiple chips the struct pci_device_id
> > driver_data field was used to hold a index to lookup chip device
> > specific information from a table. This works but creates a regressions
> > for users who uses /sys/bus/pci/drivers/nfp_netvf/new_id.
> > 
> > For example, before the change writing "19ee 6003" to new_id was
> > sufficient but after one needs to write enough fields to be able to also
> > match on the driver_data field, "19ee 6003 19ee ffffffff ffffffff 0 1".
> > 
> > The usage of driver_data field was only a convenience and in the belief
> > the driver_data field was private to the driver and not exposed in
> > anyway to users. Changing the device info lookup to a function that
> > translates from struct pci_device_id device field instead works just as
> > well and removes the user facing regression.
> > 
> > As a bonus the enum and table with lookup information can be moved out
> > from a shared header file to the only file where it's used.
> > 
> > Reported-by: Danie du Toit <[email-masked]>
> > Fixes: e900db704c8512bc ("nfp: parametrize QCP offset/size using dev_info")
> > Signed-off-by: Niklas Söderlund <[email-masked]>
> 
> Hi Simon
> 
> This is missing your own Signed-off-by:

Thanks Andrew,

I'm very sorry about that.

Signed-off-by: Simon Horman <[email-masked]>